Index: src/main/java/project/fmo/app/projcetfmo/Service/impl/KorisnikServiceImpl.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Service/impl/KorisnikServiceImpl.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Service/impl/KorisnikServiceImpl.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -1,2 +1,92 @@
-package project.fmo.app.projcetfmo.Service.impl;public class KorisnikServiceImpl {
+package project.fmo.app.projcetfmo.Service.impl;
+
+import org.springframework.security.core.authority.SimpleGrantedAuthority;
+import org.springframework.security.core.userdetails.User;
+import org.springframework.security.core.userdetails.UserDetails;
+import org.springframework.security.core.userdetails.UsernameNotFoundException;
+import org.springframework.security.crypto.password.PasswordEncoder;
+import org.springframework.stereotype.Service;
+import project.fmo.app.projcetfmo.Model.*;
+import project.fmo.app.projcetfmo.Repository.*;
+import project.fmo.app.projcetfmo.Service.KorisnikService;
+
+import java.sql.Timestamp;
+import java.time.LocalDateTime;
+import java.util.List;
+import java.util.Objects;
+import java.util.stream.Collectors;
+import java.util.stream.Stream;
+
+@Service
+public class KorisnikServiceImpl implements KorisnikService {
+
+    private final PasswordEncoder passwordEncoder;
+    private final AdminRepository adminRepository;
+    private final DostavuvacRepository dostavuvacRepository;
+
+    private final TelefnoskiBrojRepository telefnoskiBrojRepository;
+    private final KupuvacRepository kupuvacRepository;
+    private final KorisnikRepository korisnikRepository;
+
+    public KorisnikServiceImpl(PasswordEncoder passwordEncoder, AdminRepository adminRepository, DostavuvacRepository dostavuvacRepository, TelefnoskiBrojRepository telefnoskiBrojRepository, KupuvacRepository kupuvacRepository, KorisnikRepository korisnikRepository) {
+        this.passwordEncoder = passwordEncoder;
+        this.adminRepository = adminRepository;
+        this.dostavuvacRepository = dostavuvacRepository;
+        this.telefnoskiBrojRepository = telefnoskiBrojRepository;
+        this.kupuvacRepository = kupuvacRepository;
+        this.korisnikRepository = korisnikRepository;
+    }
+
+    @Override
+    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
+        Korisnik korisnik = korisnikRepository.findByImePrezime(username);
+        for (AdminKorisnik a: adminRepository.findAll()) {
+            if (a.getIdKorisnik() == korisnik.getIdKorisnik()) {
+                return new User(korisnik.getImePrezime(), korisnik.getPasswordKorisnik(), Stream.of(new SimpleGrantedAuthority("ROLE_ADMIN")).collect(Collectors.toList()));
+            }
+        }
+        for (Dostavuvac a: dostavuvacRepository.findAll()) {
+            if (a.getIdKorisnik() == korisnik.getIdKorisnik()) {
+                return new User(korisnik.getImePrezime(), korisnik.getPasswordKorisnik(), Stream.of(new SimpleGrantedAuthority("ROLE_DELIVER")).collect(Collectors.toList()));
+            }
+        }
+        for (Kupuvac a: kupuvacRepository.findAll()){
+            if (a.getIdKorisnik() == korisnik.getIdKorisnik()){
+                return new User(korisnik.getImePrezime(),korisnik.getPasswordKorisnik(), Stream.of(new SimpleGrantedAuthority("ROLE_USER")).collect(Collectors.toList()) );
+            }
+        }
+        return null;
+    }
+
+    @Override
+    public Korisnik findbyImePrezime(String ime) {
+        return korisnikRepository.findByImePrezime(ime);
+    }
+
+    @Override
+    public Korisnik findById(Integer id) {
+        return korisnikRepository.findById(id).orElse(null);
+    }
+
+    @Override
+    public Korisnik register(String username, String password, String repeatPassword, String mail, String number) {
+        if (username==null || username.isEmpty()  || password==null || password.isEmpty())
+            throw new RuntimeException();
+        if (!password.equals(repeatPassword))
+            throw new RuntimeException();
+
+        Korisnik korisnik = new Korisnik(username,password, Timestamp.valueOf(LocalDateTime.now()));
+        korisnikRepository.save(korisnik);
+        Kupuvac k = new Kupuvac(korisnik.getIdKorisnik(), mail);
+        kupuvacRepository.save(k);
+        Telefonskibroj t = new Telefonskibroj(new TelefonskibrojPK(korisnik.getIdKorisnik(),number));
+        telefnoskiBrojRepository.save(t);
+        return korisnik;
+
+    }
+
+    @Override
+    public List<Object> statistics2() {
+        return korisnikRepository.statistics2();
+    }
 }
Index: src/main/java/project/fmo/app/projcetfmo/Service/impl/KupuvacServiceImpl.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Service/impl/KupuvacServiceImpl.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Service/impl/KupuvacServiceImpl.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -1,2 +1,21 @@
-package project.fmo.app.projcetfmo.Service.impl;public class KupuvacServiceImpl {
+package project.fmo.app.projcetfmo.Service.impl;
+
+import org.springframework.stereotype.Service;
+import project.fmo.app.projcetfmo.Model.Kupuvac;
+import project.fmo.app.projcetfmo.Repository.KupuvacRepository;
+import project.fmo.app.projcetfmo.Service.KupuvacService;
+
+@Service
+public class KupuvacServiceImpl implements KupuvacService {
+
+    private final KupuvacRepository kupuvacRepository;
+
+    public KupuvacServiceImpl(KupuvacRepository kupuvacRepository) {
+        this.kupuvacRepository = kupuvacRepository;
+    }
+
+    @Override
+    public Kupuvac findById(Integer id) {
+        return kupuvacRepository.findById(id).orElse(null);
+    }
 }
Index: src/main/java/project/fmo/app/projcetfmo/Service/impl/NarackaServiceImpl.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Service/impl/NarackaServiceImpl.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Service/impl/NarackaServiceImpl.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -1,2 +1,71 @@
-package project.fmo.app.projcetfmo.Service.impl;public class NarackaServiceImpl {
+package project.fmo.app.projcetfmo.Service.impl;
+
+import org.springframework.stereotype.Service;
+import project.fmo.app.projcetfmo.Model.Kupuvac;
+import project.fmo.app.projcetfmo.Model.Naracka;
+import project.fmo.app.projcetfmo.Model.Produkt;
+import project.fmo.app.projcetfmo.Repository.KupuvacRepository;
+import project.fmo.app.projcetfmo.Repository.NarackaRepository;
+import project.fmo.app.projcetfmo.Service.NarackaService;
+
+import java.sql.Date;
+import java.util.List;
+
+@Service
+public class NarackaServiceImpl implements NarackaService {
+
+    private final NarackaRepository narackaRepository;
+    private final KupuvacRepository kupuvacRepository;
+
+    public NarackaServiceImpl(NarackaRepository narackaRepository, KupuvacRepository kupuvacRepository) {
+        this.narackaRepository = narackaRepository;
+        this.kupuvacRepository = kupuvacRepository;
+    }
+
+    @Override
+    public List<Produkt> allProductsInOrder(Integer narackaId) {
+        return null;
+    }
+
+    @Override
+    public Naracka getActiveOrder(String username) {
+        return null;
+    }
+
+    @Override
+    public Naracka findByIdKorisniktAndStatus(Integer id, String s) {
+        Kupuvac k = kupuvacRepository.findById(id).orElse(null);
+        return narackaRepository.findByKupuvacAndStatus(k,s);
+    }
+
+    @Override
+    public Naracka save(int vkupnoSuma, Date date, String status, String adresa, Kupuvac k) {
+        return narackaRepository.save(new Naracka(vkupnoSuma,date,status,adresa,k));
+    }
+
+    @Override
+    public Naracka edit(int vkupnoSuma, String status, String adresa, Integer idK, Integer idN) {
+        Kupuvac k = kupuvacRepository.findById(idK).orElse(null);
+        Naracka n = narackaRepository.findByKupuvacAndIdNaracka(k,idN);
+        n.setVkupnoSuma(n.getVkupnoSuma()+vkupnoSuma);
+        n.setStatus(status);
+        n.setAdresa(adresa);
+        narackaRepository.save(n);
+        return n;
+    }
+
+    @Override
+    public Naracka findByKupuvac(Kupuvac k) {
+        return narackaRepository.findByKupuvac(k);
+    }
+
+    @Override
+    public Naracka findByIdNaracka(Integer id) {
+        return narackaRepository.findById(id).orElse(null);
+    }
+
+    @Override
+    public List<Naracka> findAll() {
+        return narackaRepository.findAll();
+    }
 }
Index: src/main/java/project/fmo/app/projcetfmo/Service/impl/NarackaSodrziProduktServiceImpl.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Service/impl/NarackaSodrziProduktServiceImpl.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Service/impl/NarackaSodrziProduktServiceImpl.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -1,2 +1,62 @@
-package project.fmo.app.projcetfmo.Service.impl;public class NarackaSodrziProduktServiceImpl {
+package project.fmo.app.projcetfmo.Service.impl;
+
+import org.springframework.stereotype.Service;
+import project.fmo.app.projcetfmo.Model.NarackaSodrziProdukt;
+import project.fmo.app.projcetfmo.Repository.NarackaSodrziProduktRepository;
+import project.fmo.app.projcetfmo.Service.NarackaSodrziProduktService;
+
+import java.util.List;
+
+@Service
+public class NarackaSodrziProduktServiceImpl implements NarackaSodrziProduktService {
+
+   private final NarackaSodrziProduktRepository narackaSodrziProduktRepository;
+
+    public NarackaSodrziProduktServiceImpl(NarackaSodrziProduktRepository narackaSodrziProduktRepository) {
+        this.narackaSodrziProduktRepository = narackaSodrziProduktRepository;
+    }
+
+    @Override
+    public NarackaSodrziProdukt findByIdProduktAndIdNaracka(Integer idP, Integer idN) {
+        return narackaSodrziProduktRepository.findByIdProduktAndIdNaracka(idP,idN);
+    }
+
+    @Override
+    public NarackaSodrziProdukt edit(Integer idP, Integer idN, Integer quantity, Integer price) {
+        NarackaSodrziProdukt n = narackaSodrziProduktRepository.findByIdProduktAndIdNaracka(idP,idN);
+        n.setCena(price);
+        n.setKolicina(n.getKolicina()+quantity);
+        narackaSodrziProduktRepository.save(n);
+        return n;
+    }
+
+    @Override
+    public NarackaSodrziProdukt save(Integer idP, Integer idN, Integer quantity, Integer price) {
+        NarackaSodrziProdukt n = new NarackaSodrziProdukt(idP,idN,quantity, price);
+        narackaSodrziProduktRepository.save(n);
+        return n;
+    }
+
+    @Override
+    public List<NarackaSodrziProdukt> findByIdNaracka(Integer id) {
+        return narackaSodrziProduktRepository.findByIdNaracka(id);
+    }
+
+    @Override
+    public void deleteProduct(Integer id) {
+        List<NarackaSodrziProdukt> narackaSodrziProdukts = narackaSodrziProduktRepository.findByIdProdukt(id);
+        narackaSodrziProduktRepository.deleteByIdProdukt(id);
+    }
+
+    @Override
+    public List<NarackaSodrziProdukt> findAll() {
+        return narackaSodrziProduktRepository.findAll();
+    }
+
+    @Override
+    public List<NarackaSodrziProdukt> findByIdProdukt(Integer id) {
+        return narackaSodrziProduktRepository.findByIdProdukt(id);
+    }
+
+
 }
Index: src/main/java/project/fmo/app/projcetfmo/Service/impl/ProduktEOdKategorijaServiceImpl.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Service/impl/ProduktEOdKategorijaServiceImpl.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Service/impl/ProduktEOdKategorijaServiceImpl.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -1,2 +1,63 @@
-package project.fmo.app.projcetfmo.Service.impl;public class ProduktEOdKategorijaServiceImpl {
+package project.fmo.app.projcetfmo.Service.impl;
+
+import javax.transaction.Transactional;
+import org.springframework.stereotype.Service;
+import project.fmo.app.projcetfmo.Model.ProduktEOdKategorija;
+import project.fmo.app.projcetfmo.Model.ProduktEOdKategorijaPK;
+import project.fmo.app.projcetfmo.Repository.ProduktEOdKategorijaRepository;
+import project.fmo.app.projcetfmo.Service.ProduktEOdKategorijaService;
+import project.fmo.app.projcetfmo.Service.ProduktService;
+
+import java.util.List;
+
+@Service
+public class ProduktEOdKategorijaServiceImpl implements ProduktEOdKategorijaService {
+
+    private final ProduktEOdKategorijaRepository produktEOdKategorijaRepository;
+
+    public ProduktEOdKategorijaServiceImpl(ProduktEOdKategorijaRepository produktEOdKategorijaRepository) {
+        this.produktEOdKategorijaRepository = produktEOdKategorijaRepository;
+    }
+
+    @Override
+    public ProduktEOdKategorija save(int idProdukt, int idKategorija) {
+        ProduktEOdKategorija produktEOdKategorija= new ProduktEOdKategorija(new ProduktEOdKategorijaPK(idProdukt, idKategorija));
+        produktEOdKategorijaRepository.save(produktEOdKategorija);
+        return produktEOdKategorija;
+    }
+
+    @Transactional
+    @Override
+    public ProduktEOdKategorija edit(int idProdukt, int idKategorija) {
+//        ProduktEOdKategorijaPK pk = new ProduktEOdKategorijaPK(idProdukt,idKategorija);
+        ProduktEOdKategorija peodkD = produktEOdKategorijaRepository.findByIdProdukt(idProdukt);
+        produktEOdKategorijaRepository.deleteByIdProdukt(peodkD.getIdProdukt());
+        ProduktEOdKategorijaPK pk = new ProduktEOdKategorijaPK(idProdukt, idKategorija);
+        ProduktEOdKategorija peodk = new ProduktEOdKategorija(pk);
+       produktEOdKategorijaRepository.save(peodk);
+
+        return peodk;
+    }
+
+    @Override
+    public List<ProduktEOdKategorija> findAll() {
+        return produktEOdKategorijaRepository.findAll();
+    }
+
+    @Override
+    public ProduktEOdKategorija findByIdProdukt(int idProdukt) {
+        return produktEOdKategorijaRepository.findByIdProdukt(idProdukt);
+    }
+
+    @Transactional
+    @Override
+    public void deleteByIdProdukt(int idProdukt) {
+
+        this.produktEOdKategorijaRepository.deleteByIdProdukt(idProdukt);
+    }
+
+    @Override
+    public ProduktEOdKategorija findByIdProduktAndIdKategorija(int idProdukt, int idKategorija) {
+        return produktEOdKategorijaRepository.findByIdProduktAndIdKategorija(idProdukt,idKategorija);
+    }
 }
Index: src/main/java/project/fmo/app/projcetfmo/Service/impl/ProduktServiceImpl.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Service/impl/ProduktServiceImpl.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Service/impl/ProduktServiceImpl.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -1,2 +1,73 @@
-package project.fmo.app.projcetfmo.Service.impl;public class ProduktServiceImpl {
+package project.fmo.app.projcetfmo.Service.impl;
+
+import org.springframework.data.domain.Page;
+import org.springframework.data.domain.Pageable;
+import org.springframework.stereotype.Service;
+import project.fmo.app.projcetfmo.Model.AdminKorisnik;
+import project.fmo.app.projcetfmo.Model.Produkt;
+import project.fmo.app.projcetfmo.Repository.AdminRepository;
+import project.fmo.app.projcetfmo.Repository.ProduktRepository;
+import project.fmo.app.projcetfmo.Service.ProduktService;
+
+
+import java.util.List;
+import java.util.Optional;
+import java.util.Random;
+
+@Service
+public class ProduktServiceImpl implements ProduktService {
+
+    private final ProduktRepository produktRepository;
+    private final AdminRepository adminRepository;
+
+    public ProduktServiceImpl(ProduktRepository produktRepository, AdminRepository adminRepository) {
+        this.produktRepository = produktRepository;
+        this.adminRepository = adminRepository;
+    }
+
+    @Override
+    public Optional<Produkt> findById(Integer id) {
+        return produktRepository.findById(id);
+    }
+
+    @Override
+    public List<Produkt> findAll() {
+        return produktRepository.findAll();
+    }
+
+    @Override
+    public Produkt save(String ime, String opis) {
+        List<AdminKorisnik> list = adminRepository.findAll();
+        Random rand = new Random();
+        int randomIndex = rand.nextInt(list.size());
+        AdminKorisnik a = list.get(randomIndex);
+        if (a == null){
+            throw new RuntimeException();
+        }
+        Produkt p = new Produkt(ime, opis, a);
+        produktRepository.save(p);
+        return p;
+    }
+
+    @Override
+    public Produkt edit(Integer id, String ime, String opis) {
+        Produkt p = produktRepository.findById(id).orElse(null);
+        if (p == null ){
+            throw new RuntimeException();
+        }
+        p.setIme(ime);
+        p.setOpis(opis);
+        produktRepository.save(p);
+        return p;
+    }
+
+    @Override
+    public void deleteById(Integer id) {
+        produktRepository.deleteById(id);
+    }
+
+    @Override
+    public List<Object> statistics1() {
+        return produktRepository.statistics1();
+    }
 }
Index: src/main/java/project/fmo/app/projcetfmo/Web/DostavaController.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Web/DostavaController.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Web/DostavaController.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -1,2 +1,56 @@
-package project.fmo.app.projcetfmo.Web;public class DostavaController {
+package project.fmo.app.projcetfmo.Web;
+
+import org.springframework.stereotype.Controller;
+import org.springframework.ui.Model;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.PathVariable;
+import org.springframework.web.bind.annotation.PostMapping;
+import org.springframework.web.bind.annotation.RequestMapping;
+import project.fmo.app.projcetfmo.Model.Dostava;
+import project.fmo.app.projcetfmo.Model.Dostavuvac;
+import project.fmo.app.projcetfmo.Model.Korisnik;
+import project.fmo.app.projcetfmo.Service.DostavaService;
+import project.fmo.app.projcetfmo.Service.DostavuvaceService;
+import project.fmo.app.projcetfmo.Service.KorisnikService;
+import project.fmo.app.projcetfmo.Service.NarackaService;
+
+import javax.servlet.http.HttpServletRequest;
+import java.util.List;
+
+@Controller
+@RequestMapping("/delivery")
+public class DostavaController {
+
+    private final DostavaService dostavaService;
+    private final DostavuvaceService dostavuvaceService;
+    private final KorisnikService korisnikService;
+    private final NarackaService narackaService;
+
+    public DostavaController(DostavaService dostavaService, DostavuvaceService dostavuvaceService, KorisnikService korisnikService, NarackaService narackaService) {
+        this.dostavaService = dostavaService;
+        this.dostavuvaceService = dostavuvaceService;
+        this.korisnikService = korisnikService;
+        this.narackaService = narackaService;
+    }
+
+
+    @GetMapping
+    public String getDelivery(Model model, HttpServletRequest req){
+        String username = req.getRemoteUser();
+        Korisnik korisnik = korisnikService.findbyImePrezime(username);
+        Dostavuvac dostavuvac = dostavuvaceService.findById(korisnik.getIdKorisnik());
+        List<Dostava> dostavaList = dostavaService.findByIdKorisnikAndStatus(dostavuvac, "za dostava");
+        model.addAttribute("user", korisnik);
+        model.addAttribute("orders", narackaService.findAll());
+        model.addAttribute("delivers", dostavaList);
+        model.addAttribute("bodyContent", "delivery");
+        return "master_template";
+    }
+
+    @PostMapping("/{id}")
+    public String OrderDelivered(@PathVariable Integer id){
+        dostavaService.edit(id);
+        return  "redirect:/delivery";
+    }
+
 }
Index: src/main/java/project/fmo/app/projcetfmo/Web/HomeController.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Web/HomeController.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Web/HomeController.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -9,11 +9,19 @@
 @Controller
 @RequestMapping({"/","/home"})
-public class StoreController {
+public class HomeController {
 
 
     @GetMapping
-    public String getHomePage(){
-        return "home";
+    public String getHomePage(Model model){
+        model.addAttribute("bodyContent", "home");
+        return "master_template";
     }
 
+    @GetMapping("/access_denied")
+    public String getAccessDeniedPage(Model model) {
+        model.addAttribute("bodyContent", "access_denied");
+        return "master-template";
+    }
+
+
 }
Index: src/main/java/project/fmo/app/projcetfmo/Web/LoginController.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Web/LoginController.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Web/LoginController.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -1,2 +1,46 @@
-package project.fmo.app.projcetfmo.Web;public class LoginController {
+package project.fmo.app.projcetfmo.Web;
+
+
+import org.springframework.stereotype.Controller;
+import org.springframework.ui.Model;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.PostMapping;
+import org.springframework.web.bind.annotation.RequestMapping;
+import project.fmo.app.projcetfmo.Model.Korisnik;
+import project.fmo.app.projcetfmo.Model.exception.InvalidUserCredentialsException;
+import project.fmo.app.projcetfmo.Service.AuthService;
+
+import javax.servlet.http.HttpServletRequest;
+
+@Controller
+@RequestMapping("/login")
+public class LoginController {
+
+    private final AuthService authService;
+
+    public LoginController(AuthService authService) {
+        this.authService = authService;
+    }
+
+    @GetMapping
+    public String getLoginPage(Model model) {
+        model.addAttribute("bodyContent","login");
+        return "master-template";
+    }
+
+    @PostMapping
+    public String login(HttpServletRequest request, Model model) {
+        Korisnik user = null;
+        try{
+            user = this.authService.login(request.getParameter("username"),
+                    request.getParameter("password"));
+            request.getSession().setAttribute("user", user);
+            return "redirect:/home";
+        }
+        catch (InvalidUserCredentialsException exception) {
+            model.addAttribute("hasError", true);
+            model.addAttribute("error", exception.getMessage());
+            return "login";
+        }
+    }
 }
Index: src/main/java/project/fmo/app/projcetfmo/Web/LogoutController.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Web/LogoutController.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Web/LogoutController.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -1,2 +1,18 @@
-package project.fmo.app.projcetfmo.Web;public class LogoutController {
+package project.fmo.app.projcetfmo.Web;
+
+import org.springframework.stereotype.Controller;
+import org.springframework.web.bind.annotation.GetMapping;
+import org.springframework.web.bind.annotation.RequestMapping;
+
+import javax.servlet.http.HttpServletRequest;
+
+@Controller
+@RequestMapping("/logout")
+public class LogoutController {
+
+    @GetMapping
+    public String logout(HttpServletRequest request) {
+        request.getSession().invalidate();
+        return "redirect:/";
+    }
 }
Index: src/main/java/project/fmo/app/projcetfmo/Web/NarackaController.java
===================================================================
--- src/main/java/project/fmo/app/projcetfmo/Web/NarackaController.java	(revision 1dd922639ddb0583e5e61efee73ed97f3f8aa165)
+++ src/main/java/project/fmo/app/projcetfmo/Web/NarackaController.java	(revision d14176d864a9e378a444b7d3a7c0e15a27d0113d)
@@ -1,2 +1,76 @@
-package project.fmo.app.projcetfmo.Web;public class NarackaController {
+package project.fmo.app.projcetfmo.Web;
+
+import org.springframework.stereotype.Controller;
+import org.springframework.ui.Model;
+import org.springframework.web.bind.annotation.*;
+import project.fmo.app.projcetfmo.Model.*;
+import project.fmo.app.projcetfmo.Service.*;
+
+import javax.servlet.http.HttpServletRequest;
+import java.util.List;
+
+@Controller
+@RequestMapping("/order")
+public class NarackaController {
+
+    private final NarackaService narackaService;
+    private final NarackaSodrziProduktService narackaSodrziProduktService;
+    private final KorisnikService korisnikService;
+    private final KupuvacService kupuvacService;
+    private final CenaService cenaService;
+
+    private final ProduktService produktService;
+
+    public NarackaController(NarackaService narackaService, NarackaSodrziProduktService narackaSodrziProduktService, KorisnikService korisnikService, KupuvacService kupuvacService, CenaService cenaService, ProduktService produktService) {
+        this.narackaService = narackaService;
+        this.narackaSodrziProduktService = narackaSodrziProduktService;
+        this.korisnikService = korisnikService;
+        this.kupuvacService = kupuvacService;
+        this.cenaService = cenaService;
+        this.produktService = produktService;
+    }
+
+    @GetMapping
+    public String getShoppingCartPage(@RequestParam(required = false) String error,
+                                      HttpServletRequest req,
+                                      Model model) {
+        if (error != null && !error.isEmpty()) {
+            model.addAttribute("hasError", true);
+            model.addAttribute("error", error);
+        }
+        String username = req.getRemoteUser();
+        Korisnik korisnik = korisnikService.findbyImePrezime(username);
+        Kupuvac kupuvac = kupuvacService.findById(korisnik.getIdKorisnik());
+        Naracka naracka = this.narackaService.findByIdKorisniktAndStatus(kupuvac.getIdKorisnik(),"aktivna");
+        if(naracka == null){
+            model.addAttribute("bodyContent", "home");
+            return "master_template";
+        }
+        List<NarackaSodrziProdukt> narackaSodrziProdukt = narackaSodrziProduktService.findByIdNaracka(naracka.getIdNaracka());
+        List<Produkt> produktList =  produktService.findAll();
+        model.addAttribute("order", naracka);
+        model.addAttribute("products", produktList);
+        model.addAttribute("po", narackaSodrziProdukt);
+        model.addAttribute("prices", cenaService.findAll());
+        model.addAttribute("bodyContent", "cart");
+        return "master_template";
+    }
+
+    @PostMapping("/{id}/success")
+    public String processOrder(@PathVariable Integer id,HttpServletRequest req,@RequestParam(required = false) String address){
+        Naracka n = narackaService.findByIdNaracka(id);
+        String username = req.getRemoteUser();
+        Korisnik korisnik = korisnikService.findbyImePrezime(username);
+        Kupuvac kupuvac = kupuvacService.findById(korisnik.getIdKorisnik());
+        if(address!=null) {
+            narackaService.edit(0, "se sprema", address, kupuvac.getIdKorisnik(), n.getIdNaracka());
+        }
+        else {
+            narackaService.edit(0, "se sprema", "/", kupuvac.getIdKorisnik(), n.getIdNaracka());
+        }
+        return "redirect:/products";
+    }
+
+
+
 }
